import '../attributes/dynamic/hidden.dart';
import '../attributes/layout/aspect_ratio.dart';
import '../attributes/layout/constraints.dart';
import '../attributes/layout/flex.dart';
import '../attributes/painting/alignment.dart';
import '../attributes/painting/axis.dart';
import '../attributes/painting/border.dart';
import '../attributes/painting/border_radius.dart';
import '../attributes/painting/box_decoration.dart';
import '../attributes/painting/box_fit.dart';
import '../attributes/painting/opacity.dart';
import '../attributes/painting/rotate.dart';
import '../attributes/painting/shadow.dart';
import '../attributes/primitives/color.dart';
import '../attributes/primitives/size.dart';
import '../attributes/primitives/space.dart';
import '../attributes/rendering/flex/cross_axis_alignment.dart';
import '../attributes/rendering/flex/flex_fit.dart';
import '../attributes/rendering/flex/main_axis_alignment.dart';
import '../attributes/rendering/flex/main_axis_size.dart';
import '../attributes/text/debug_label.dart';
import '../attributes/text/font_family.dart';
import '../attributes/text/font_size.dart';
import '../attributes/text/font_style.dart';
import '../attributes/text/font_weight.dart';
import '../attributes/text/letter_spacing.dart';
import '../attributes/text/locale.dart';
import '../attributes/text/max_lines.dart';
import '../attributes/text/soft_wrap.dart';
import '../attributes/text/text_align.dart';
import '../attributes/text/text_baseline.dart';
import '../attributes/text/text_direction.dart';
import '../attributes/text/text_height.dart';
import '../attributes/text/text_overflow.dart';
import '../attributes/text/text_scale_factor.dart';
import '../attributes/text/text_width_basis.dart';
import '../attributes/text/word_spacing.dart';

class MixAttributes {
  MarginAttribute? margin;
  PaddingAttribute? padding;
  AlignmentAttribute? alignment;
  ConstraintsAttribute? constraints;
  HiddenAttribute? display;
  BackgroundColorAttribute? backgroundColor;
  BorderAttribute? border;
  BorderRadiusAttribute? borderRadius;
  BoxShadowAttribute? boxShadow;
  BoxDecorationAttribute? decoration;
  HeightAttribute? height;
  MaxHeightAttribute? maxHeight;
  MinHeightAttribute? minHeight;
  WidthAttribute? width;
  MaxWidthAttribute? maxWidth;
  MinWidthAttribute? minWidth;
  AxisAttribute? axis;
  MainAxisSizeAttribute? mainAxisSize;
  CrossAxisAlignmentAttribute? crossAxisAlignment;
  MainAxisAlignmentAttribute? mainAxisAlignment;
  GapAttribute? gap;
  RotateAttribute? rotate;
  OpacityAttribute? opacity;
  FlexAttribute? flex;
  FlexFitAttribute? flexFit;
  BoxFitAttribute? boxFit;
  AspectRatioAttribute? aspectRatio;
  // Text Attributes
  TextColorAttribute? textColor;
  TextAlignAttribute? textAlign;
  FontSizeAttribute? fontSize;
  WordSpacingAttribute? wordSpacing;
  LetterSpacingAttribute? letterSpacing;
  TextBaselineAttribute? textBaseline;
  MaxLinesAttribute? maxLines;
  FontFamilyAttribute? fontFamily;
  FontWeightAttribute? fontWeight;
  TextDirectionAttribute? textDirection;
  FontStyleAttribute? fontStyle;
  LocaleAttribute? locale;
  TextOverflowAttribute? textOverflow;
  SoftWrapAttribute? softWrap;
  TextScaleFactorAttribute? textScaleFactor;
  TextWidthBasisAttribute? textWidthBasis;
  DebugLabelAttribute? debugLabel;
  TextHeightAttribute? textHeight;
}
